#include <iostream>
using namespace std;

struct nod {
    int info;
    nod* urm;
};

void CitesteLista(nod* &prim, nod* &ultim);
void AdaugaSfarsit(nod* &prim, nod* &ultim, int val);
void AdaugaInceput(nod* &prim, nod* &ultim, int val);
void StergeInceput(nod* &prim, nod* &ultim);
void ScrieLista(nod* prim);

int main()
{
    nod *prim = nullptr,
        *ultim = nullptr;
    int val;
    char ch;

    do
    {
        cout << "S - Adauga la sfarsit\n";
        cout << "I - Adauga la inceput\n";
        cout << "D - Sterge la inceput\n";
        cout << "A - Afiseaza lista\n";
        cout << "X - Iesire\n";

        cin >> ch;

        switch (ch)
        {
            case 'S' :
            case 's' : cout << "Informatia: "; cin >> val;
                       AdaugaSfarsit(prim, ultim, val);
                       break;

            case 'I' :
            case 'i' : cout << "Informatia: "; cin >> val;
                       AdaugaInceput(prim, ultim, val);
                       break;

            case 'D' :
            case 'd' : StergeInceput(prim, ultim);
                       break;
            case 'A' :
            case 'a' : ScrieLista(prim);
                       break;

            case 'X' :
            case 'x' : cout << "Servus!\n";
                       break;

            default  : cout << "Alegeti din meniu!\n";
                       break;
        }

    } while (ch != 'X' && ch != 'x');
}


void AdaugaSfarsit(nod* &prim, nod* &ultim, int val)
{
    if (prim == nullptr) /// daca lista e vida
    {
        prim = new nod;
        prim->info = val;
        prim->urm = nullptr;
        ultim = prim;
    }
    else
    {
        nod* p = new nod;
        p->info = val;
        p->urm = nullptr;
        ultim->urm = p;
        ultim = p;
    }
}

void AdaugaInceput(nod* &prim, nod* &ultim, int val)
{
    if (prim == nullptr) /// daca lista e vida
    {
        prim = new nod;
        prim->info = val;
        prim->urm = nullptr;
        ultim = prim;
    }
    else
    {
        nod* p = new nod;
        p->info = val;
        p->urm = prim;
        prim = p;
    }
}

void ScrieLista(nod* prim)
{
    if (prim == nullptr)
        cout << "Lista vida!\n";
    else
    {
        for (nod* p = prim; p; p = p->urm)
            cout << p->info << ' ';
        cout << '\n';
    }
}

void StergeInceput(nod* &prim, nod* &ultim)
{
    if (prim == nullptr)
        cout << "Lista vida!\n";
    else
        if (prim->urm == nullptr) /// un singur nod in lista
        {
            delete prim;
            prim = ultim = nullptr;
        }
        else /// cel putin 2 noduri
        {
            nod* p = prim;
            prim = prim->urm;
            delete p;
        }

}
